"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

function _react() {
  const data = _interopRequireDefault(require("react"));

  _react = function _react() {
    return data;
  };

  return data;
}

function _antd() {
  const data = require("antd");

  _antd = function _antd() {
    return data;
  };

  return data;
}

function _reactI18next() {
  const data = require("react-i18next");

  _reactI18next = function _reactI18next() {
    return data;
  };

  return data;
}

function _client() {
  const data = require("@nocobase/client");

  _client = function _client() {
    return data;
  };

  return data;
}

var _WorkflowCanvas = require("../WorkflowCanvas");

var _calculators = require("../calculators");

var _collection = require("../schemas/collection");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); enumerableOnly && (symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; })), keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = null != arguments[i] ? arguments[i] : {}; i % 2 ? ownKeys(Object(source), !0).forEach(function (key) { _defineProperty(target, key, source[key]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)) : ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

var _default = {
  title: '{{t("Query record")}}',
  type: 'query',
  group: 'collection',
  fieldset: {
    'config.collection': _collection.collection,
    'config.multiple': {
      type: 'boolean',
      title: '{{t("Multiple records")}}',
      name: 'config.multiple',
      'x-decorator': 'FormItem',
      'x-component': 'Checkbox',
      'x-component-props': {
        disabled: true
      }
    },
    'config.params': {
      type: 'object',
      name: 'config.params',
      title: '',
      'x-decorator': 'FormItem',
      properties: {
        filter: _collection.filter
      }
    }
  },
  view: {},
  scope: {
    useCollectionDataSource: _client().useCollectionDataSource
  },
  components: {
    VariableComponent: _calculators.VariableComponent
  },

  getter({
    type,
    options,
    onChange: _onChange
  }) {
    var _collections$find;

    const _useTranslation = (0, _reactI18next().useTranslation)(),
          t = _useTranslation.t;

    const compile = (0, _client().useCompile)();

    const _useCollectionManager = (0, _client().useCollectionManager)(),
          _useCollectionManager2 = _useCollectionManager.collections,
          collections = _useCollectionManager2 === void 0 ? [] : _useCollectionManager2;

    const _useFlowContext = (0, _WorkflowCanvas.useFlowContext)(),
          nodes = _useFlowContext.nodes;

    const _nodes$find = nodes.find(n => n.id == options.nodeId),
          config = _nodes$find.config;

    const collection = (_collections$find = collections.find(item => item.name === config.collection)) !== null && _collections$find !== void 0 ? _collections$find : {
      fields: []
    };
    return _react().default.createElement(_antd().Select, {
      value: options.path,
      placeholder: t('Fields'),
      onChange: path => {
        _onChange({
          type,
          options: _objectSpread(_objectSpread({}, options), {}, {
            path
          })
        });
      }
    }, collection.fields.filter(field => {
      var _field$uiSchema;

      return _calculators.BaseTypeSet.has((_field$uiSchema = field.uiSchema) === null || _field$uiSchema === void 0 ? void 0 : _field$uiSchema.type);
    }).map(field => _react().default.createElement(_antd().Select.Option, {
      key: field.name,
      value: field.name
    }, compile(field.uiSchema.title))));
  }

};
exports.default = _default;