import { Plugin } from '@nocobase/server';
import { Transactionable } from '@nocobase/database';
import { Registry } from '@nocobase/utils';
import { Trigger } from './triggers';
import { Instruction } from './instructions';
import Processor from './Processor';
import WorkflowModel from './models/Workflow';
import ExecutionModel from './models/Execution';
export default class WorkflowPlugin extends Plugin {
    instructions: Registry<Instruction>;
    triggers: Registry<Trigger>;
    onBeforeSave: (instance: WorkflowModel, options: any) => Promise<void>;
    getName(): string;
    load(): Promise<void>;
    toggle(workflow: WorkflowModel, enable?: boolean): void;
    trigger(workflow: any, context: Object, options?: Transactionable): Promise<any>;
    createProcessor(execution: ExecutionModel, options?: {}): Processor;
}
